///////////////////////////////////////////////////////////////////////////////////////////
//  Disclaimer: This wrapper library is actually infused with the almighty engrams of 
//  Christopher Dudley. If left in it's current sorry state, I can guarantee that this
//  code will make your cat walk funny, format your harddisk, and turn that gray thing
//  resting in your skull to tapioca pudding. Sucks to be you, I claim no responsibility.
///////////////////////////////////////////////////////////////////////////////////////////
#ifndef             MY_APPLICATION_H                // Include guard required by law...
#define             MY_APPLICATION_H
#define             WIN32_LEAN_AND_MEAN             // I wish...
#include            <windows.h>

class Application
{
public:
  /////////////////////////////////////////////////////////////////////////////////////////
  // Construction and destruction, no surprises here.
  /////////////////////////////////////////////////////////////////////////////////////////
  Application( char* appname );
  ~Application();

  /////////////////////////////////////////////////////////////////////////////////////////
  // Big 'ol control methods.
  /////////////////////////////////////////////////////////////////////////////////////////
  void            Run  ( void );
  void            Halt ( void );
  void            Error( const char* msg );

  /////////////////////////////////////////////////////////////////////////////////////////
  // Handle window creation given a target width, height, and fullscreen/windowed flag.
  /////////////////////////////////////////////////////////////////////////////////////////
  void            Create( int h, int w, bool fs );

  /////////////////////////////////////////////////////////////////////////////////////////
  // These are for the user to override and implement for himself.
  /////////////////////////////////////////////////////////////////////////////////////////
  virtual void    Initialize( void )    {}          // Stubby...
  virtual void    Finalize  ( void )    {}          // Stubby...
  virtual void    Render    ( void )    {}          // Stubby...
  virtual void    Update    ( void )    {}          // Stubby...
  virtual LRESULT WindowHandler( UINT msg, WPARAM wParam, LPARAM lParam );

  ///////////////////////////////////////////////////////////////////////////////////////
  // Accessor methods for internal goodies.
  ///////////////////////////////////////////////////////////////////////////////////////
  HWND            hWnd     ( void )   {return(m_hWnd);     }
  HINSTANCE       hInstance( void )   {return(m_hInstance);}

protected:
  ///////////////////////////////////////////////////////////////////////////////////////
  // These members hold the handles that we need to talk to Windows properly.
  ///////////////////////////////////////////////////////////////////////////////////////
  HWND            m_hWnd;
  HINSTANCE       m_hInstance;
  MSG             m_hMsg;
  WNDCLASS        m_wClass;

  ///////////////////////////////////////////////////////////////////////////////////////
  // Status indicators and counters for the GDK. These keep track of the intrinsic state
  // of the GDK at all times, and can be used for statistical purposes.
  ///////////////////////////////////////////////////////////////////////////////////////
  char *          m_pName;
  unsigned long   m_iFrames;
  int             m_iWidth;
  int             m_iHeight;
  int             m_iBPP;
  bool            m_bFullscreen;
  bool            m_bReady;
  bool            m_bRunning;
};

#endif                                              // End almighty include-guard.
